#include <stdlib.h>
#include <ncurses.h>

#include "include/main.h"
#include "include/field.h"
#include "include/apple.h"
#include "../config.h"

Field *new_field(size_t num, int x_max, int y_max) {
    Field *f;
    f = (Field *)malloc(sizeof(Field));
    if (!f)
        die("field.c: new_field(): 'f' is null pointer");

    f->num = num;
    f->x_max = x_max;
    f->y_max = y_max;
    f->a = (Apple **)malloc(sizeof(Apple *) * f->num);
    if (!f->a)
        die("field.c: new_field(): 'f->a' is null pointer");
    for (size_t i = 0; i < f->num; i++)
        f->a[i] = new_apple(irandom(5, f->x_max - 5), irandom(5, f->y_max - 5));

    return f;
}

void delete_field(Field *f) {
    for (size_t i = 0; i < f->num; i++)
        delete_apple(f->a[i]);
    free_s(f);
}

void field_print(Field *f) {
    for (size_t i = 0; i < f->num; i++)
        mvaddch(f->a[i]->y, f->a[i]->x, apple_ch);
}
